{{NMEA message generator for testing GPS parser

}}
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

VAR
  long                stack[22]
  long                Bit_delay
  byte                tx_pin

PUB Start
  cognew(Main,@stack)
  
PUB Main 
  tx_pin := 7
  Bit_Delay := 80_000_000 / 4800   

  dira[tx_pin]~~
  outa[tx_pin]~~
  waitcnt(cnt+clkfreq)

  repeat
    waitcnt(cnt + clkfreq / 2)
    send(@GGA_string)
    waitcnt(cnt + clkfreq / 2)
    send(@RMC_string)
   
PRI Send(stringPtr) | cksum

    cksum := 0
    tx("$")
    repeat strsize(stringPtr)
      tx(byte[stringPtr])                                                       'Transmit each byte in the string
      cksum ^= byte[stringPtr++]
    tx("*")
    hex(cksum,2)
    tx($0D)
    tx($0A)
    
PRI Hex(value, digits)

  value <<= (8 - digits) << 2
  repeat digits                                         'do it for the number of hex digits being transmitted
    Tx(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))'  Transmit the ASCII value of the hex characters

PRI Tx(txByte) | time

  time := cnt

  outa[Tx_pin]~
  repeat 8
    waitcnt(time += Bit_Delay)
    outa[Tx_pin] := txByte & 1
    txByte >>= 1
  waitcnt(time += Bit_Delay)
  outa[Tx_pin]~~
  waitcnt(time += Bit_Delay)

DAT                     org
GGA_string              byte      "GPGGA,193159.000,3835.4983,N,07707.1871,W,1,09,1.3,0.4,M,-33.5,M,,0000",0
RMC_string              byte      "GPRMC,193159.000,A,3835.4983,N,07707.1871,W,48.38,336.78,160813,,,A",0